Bug 621673 - default to aligning the LVM data areas on a 1MB boundary
default to aligning the LVM data areas on a 1MB boundary
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: lvm2 (Show other bugs)
6.0
All Linux
low Severity medium
: rc
: ---
Assigned To: Mike Snitzer
Corey Marthaler
:
Depends On:
Blocks: 621684 623458 623703
  Show dependency treegraph
 
Reported: 2010-08-05 15:26 EDT by Mike Snitzer
Modified: 2010-11-10 16:08 EST (History)
9 users (show)

See Also:
Fixed In Version: lvm2-2.02.72-7.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 621684 623458 (view as bug list)
Environment:
Last Closed: 2010-11-10 16:08:39 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Mike Snitzer 2010-08-05 15:26:52 EDT
Description of problem:
The new standard in the storage industry is to default alignment of data
areas to 1MB.  fdisk, parted, and mdadm have all been updated to this
default.

Update LVM to align the PV's data area start (pe_start) to 1MB.  This
provides a more useful default than the previous default of 64K (which
generally ended up being a 192K pe_start once the first metadata area
was created).

Having recently boasted about the new 1MB default in the RHEL6 storage
stack I was soon faced with the harsh reality that LVM was a weak link
(on legacy hardware that doesn't export I/O topology limits).

This meant that an 8 disk HW raid0 array (with 64K chunk_size) ended up
having a PV pe_start that was not aligned on a full-stripe boundary.  As
such the array was misaligned -- resulting is suboptimal performance. 
The array would've been configured optimally "out of the box" had LVM
used a default alignment of 1MB.

Steps to Reproduce:
1. pvcreate /dev/sdd
2. vgcreate test /dev/sdd
3. pvs -o name,vg_mda_size,pe_start
  
Actual results:
# pvs -o name,vg_mda_size,pe_start                                                                                                                                     
  PV         VMdaSize  1st PE
  /dev/sdd     188.00k 192.00k

Expected results:
# pvs -o name,vg_mda_size,pe_start                                                                                                                                     
  PV         VMdaSize  1st PE
  /dev/sdd    1020.00k   1.00m
Comment 1 Mike Snitzer 2010-08-05 15:27:48 EDT
Patch posted to lvm-devel:
http://www.redhat.com/archives/lvm-devel/2010-August/msg00035.html
Comment 2 Mike Snitzer 2010-08-09 12:59:12 EDT
I'll be revising the patch referenced in comment#1.
Comment 6 Corey Marthaler 2010-08-25 16:01:36 EDT
[root@taft-01 ~]# pvs -o name,vg_mda_size,pe_start
  PV         VMdaSize  1st PE
  /dev/sda2    188.00k 192.00k
  /dev/sdb1   1020.00k   1.00m
  /dev/sdc1   1020.00k   1.00m
  /dev/sdd1   1020.00k   1.00m
  /dev/sde1   1020.00k   1.00m
  /dev/sdf1   1020.00k   1.00m
  /dev/sdg1   1020.00k   1.00m
  /dev/sdh1   1020.00k   1.00m

Feature verified in the latest rpms.
2.6.32-59.1.el6.x86_64

lvm2-2.02.72-8.el6    BUILT: Wed Aug 18 10:41:52 CDT 2010
lvm2-libs-2.02.72-8.el6    BUILT: Wed Aug 18 10:41:52 CDT 2010
lvm2-cluster-2.02.72-8.el6    BUILT: Wed Aug 18 10:41:52 CDT 2010
udev-147-2.22.el6    BUILT: Fri Jul 23 07:21:33 CDT 2010
device-mapper-1.02.53-8.el6    BUILT: Wed Aug 18 10:41:52 CDT 2010
device-mapper-libs-1.02.53-8.el6    BUILT: Wed Aug 18 10:41:52 CDT 2010
device-mapper-event-1.02.53-8.el6    BUILT: Wed Aug 18 10:41:52 CDT 2010
device-mapper-event-libs-1.02.53-8.el6    BUILT: Wed Aug 18 10:41:52 CDT 2010
cmirror-2.02.72-8.el6    BUILT: Wed Aug 18 10:41:52 CDT 2010
Comment 7 releng-rhel@redhat.com 2010-11-10 16:08:39 EST
Red Hat Enterprise Linux 6.0 is now available and should resolve
the problem described in this bug report. This report is therefore being closed
with a resolution of CURRENTRELEASE. You may reopen this bug report if the
solution does not work for you.

Note You need to log in before you can comment on or make changes to this bug.